/* JavaScript form validation. I have consulted http://www.w3resource.com/javascript/form/javascript-sample-registration-form-validation.php 
http://www.codeproject.com/Tips/492632/Email-Validation-in-JavaScript while designing and programing this section*/

// The main function CheckForm calls other functions to perform validation on all the required fields
function CheckForm(registration)
{

 //These are declaration where each required field on the form is assigned to a variable
    var fname1 = document.registration.pname;
	var frelation = document.registration.relation;
	var fphone = document.registration.phone;
    var fprovince = document.registration.province;
	var fcity = document.registration.city;
	var femail = document.registration.email;
	var fname2 = document.registration.cname;
	var fage = document.registration.age;
	var fmgender = document.registration.mgender;  
	var ffgender = document.registration.fgender
   
      // If statements are used to send each variable to separate validation functions to be excuted in the sequence of the if statement.
        
            if(allLetter(fname1))
            {
			if(relationCheck(frelation))
			{
			if(phoneCheck(fphone))
            {
			if(provinceCheck(fprovince))
			{
			if(cityCheck(fcity))
			{
			if(emailCheck(femail))
			{
			if(allLetter2(fname2))
			{
			if(ageCheck(fage))
			{
			if(validsex(fmgender,ffgender))  
			{
			}
			}
			}
			}
			}
			}
			}
            }
			}
                   
			return false;
}


// validation for parent name check. Validated to check if input entered is alphabetic. Else it displays an alert and returns false.
function allLetter(fname1)
{
    var letters = /^[A-Za-z]+$/;
    if(fname1.value.match(letters))
    {
        return true;
    }
    else
    {
        alert('Name must have alphabet characters only');
		document.registration.fname1.focus() ;
        return false;
    }
}

// Validates if the relationship field has bee left blank. Alerts to correct if left blank
function relationCheck(frelation)
{
     if( frelation.value == "" )
         {
            alert( "Please provide your relationship to the child!" );
            return false;
			}
       else
    {
                return true;
    }
}

/* Validates if the phone field has been left blank or nonnumeric characters have been entered. 
Number.parseInt() method parses a string argument and returns an integer
Checks if the 10 digits have been entered */
function phoneCheck(fphone) {
    var error = "";
    var clean = fphone.value.replace(/[\(\)\.\-\ ]/g, '');
 
   if (fphone.value == "") {
        error = "You didn't enter a phone number.\n";
        fphone.style.background = 'Yellow';
        alert(error);
		return false;
 
    } else if (isNaN(parseInt(clean))) {
        error = "The phone number contains illegal characters. Don't include dash (-)\n";
        fphone.style.background = 'Yellow';
        alert(error);
		return false;
    } else if (!(clean.length == 10)) {
        error = "The phone number is the wrong length. Make sure you included an area code. Don't include dash (-)\n";
        fphone.style.background = 'Yellow';
        alert(error);
		return false;
    }
    return true;
}


/* Validates if province was chosen from the list of provinces. fprovince is initialized with default value to check 
if an another option was chosen from the list.*/
function provinceCheck(fprovince)
{
    if(fprovince.value == "Default")
    {
        alert('Select a province from the list');
        return false;
    }
    else
    {
        return true;
    }
}

//Validates City field on the form to check if has been left blank
function cityCheck(fcity)
{
    if(fcity.value == "")
    {
        alert('Enter a city');
        return false;
    }
    else
    {
        return true;
    }
}

/* validates email field on the form. It checks if the format provided includes @ and dot sign. It was interesting to come across several 
 methods of validating email. Sources are: http://www.htmlgoodies.com/beyond/javascript/improved-form-handling-using-javascript.html
 Following are some  of the other ways : 
 1st method :
 ------------
  function validateEmail(email)
      {
         atpos = emailID.indexOf("@");
         dotpos = emailID.lastIndexOf(".");
         
         if (atpos < 1 || ( dotpos - atpos < 2 )) 
         {
            alert("Please enter correct email ID")
            document.myForm.EMail.focus() ;
            return false;
         }
		 else
		{
        alert('Form Successfully Submitted');
        window.location.reload()
        return true;}
      }
	  
	  
2nd method:
-----------
  var email = document.getElementById('txtemail');
  var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;

    if (!filter.test(email.value)) {
        alert('Please provide a valid email address');
       email.focus;
        return false;
    }
	else
    {
       // return true;
    }

3rd method
--------------
/*function CheckForm(email)
      {
         var emailID = document.registration.email.value;
         atpos = emailID.indexOf("@");
         dotpos = emailID.lastIndexOf(".");
         
       
         
		  if( document.registration.pname.value == "" )
         {
            alert( "Please provide the parent name!" );
            document.registration.Name.focus() ;
            return false;
			}
			
        
		 if(document.registration.province == "Default")
		{
        alert('Select your province from the list');
        return false;
		}
    if( document.registration.email.value == "" )
         {
            alert( "Please provide your Email!" );
            document.registration.email.focus() ;
            return false;
         }
            if (atpos < 1 || ( dotpos - atpos < 2 )) 
         {
            alert("Please enter correct email ID. It needs to be in sample@live.com format")
            document.registration.email.focus() ;
            return false;
			}
        
         if( document.registration.province.value == "-1" )
         {
            alert( "Please choose a Province" );
            return false;
         }
         return( true );
      }
	  
However, I ended up using the following because it was simple to understand and the shortest */
	  
function emailCheck(femail)  
{  
var clear = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;  
	
	if(femail.value.match(clear))  
	{  
		return true;  
	}  
	else  
	{  
		alert("You have entered an invalid email address! Format: live@html.com");  
		femail.focus();  
		return false;  
	}  
}  

//Validates  the child's name and makes sure that the field is not empty and is alphabetic

function allLetter2(fname2)
{
    var letters = /^[A-Za-z]+$/;
    if(fname2.value.match(letters))
    {
        return true;
    }
    else
    {
        alert('Child name must have alphabet characters only');
		fname2.focus() ;
        return false;
    }
	 
}

//Validates if the age field was filled out. It does not matter if it is numeric or alphabetic as long as its not empty
		 
function ageCheck(fage) 
{
    var error = "";
  
   if (fage.value == "") {
        error = "You didn't enter an age for the child.\n";
        fage.style.background = 'Yellow';
        alert(error);
		return false;
     } 
	 else
     { 
	return true;
	
	}
}

/* I came across several methods of checking if an option button was chosen. They were all very interesting as they 
all made use of different functionalities of JavaScript. Following are some of the methods:

1st Method:
-------------
function send(genders) {
    var error = "";
  
  if ( ( genders[0].checked == false ) && ( gender[1].checked == false ) )
{
alert ( "Please choose your Gender: Male or Female" );
return false;
}
if (ErrorText= "")
 { 
form.submit() 
alert ( "Your message has been sent" );
}
}
    

2nd method:
------------
Function genderCheck(gender)
{
	ErrorText= "";
	if ( ( form.gender[0].checked == false ) && ( form.gender[1].checked == false ) )
	{
	alert ( "Please choose your Gender: Male or Female" );
	return false;
	}
	if (ErrorText= "") { form.submit() }
}

3rd method:
------------

function send(genders)
 {
                var genders = document.getElementsByName("gender");
                if (genders[0].checked == true) {
                    alert("Your gender is male");
                } else if (genders[1].checked == true) {
                    alert("Your gender is female");
                } else {
                    // no checked
                    var msg = '<span style="color:red;">You must select your gender!</span><br /><br />';
                    document.getElementById('msg').innerHTML = msg;
                    return false;
                }
                return true;
            }
	
I ended up using the following because after a lot of debugging I could only get this code to work. The function genderCheck
passes  2 variables fmgender and ffgender to the loop. X is a counter which has been initialized. It increments if any options are chosen.
If the counter remains at 0 it means no options were chosen and alert is sendout. Else form is submitted and user is notified */

function validsex(fmgender,ffgender)  
	{  
		x=0;  
	  
		if(fmgender.checked)   
	{  
		x++;  
	} 
		if(ffgender.checked)  
	{  
		x++;   
	}  
		if(x==0)  
	{  
		alert('Select Male/Female');  
		umgender.focus();  
		return false;  
	}  
		else  
		{  
		alert('Form Successfully Submitted');  
		window.location.reload()  
		return true;
		}  
}

